/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
/** @file
 *
 * contains stuff for simple config files.
 *
 * @author Reinhard Pfau
 * 
 * @copyright &copy; Copyright 2007-2008 by Intra2net AG
 */

#ifndef __I2N_CONFIGFILE_HPP__
#define __I2N_CONFIGFILE_HPP__

#include <string>
#include <istream>
#include <boost/function.hpp>

#include "i2n_configdata.hpp"

namespace I2n
{


/*
**
*/

typedef boost::function< std::string(const std::string&) > ValueDecoder;


bool load_ini_config_file(
    const std::string& filename,
    ConfigData& result,
    const ValueDecoder& decoder = ValueDecoder()
);


bool load_ini_config(
    std::istream& f,
    ConfigData& result,
    const ValueDecoder& decoder = ValueDecoder()
);



} // eo namespace I2n

#endif
